unit FileChk;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, StdCtrls, Buttons, ExtCtrls, ComCtrls, DBLists, Mask,
  ToolEdit, BFC_FileCheck, ShellApi, ShlObj, BFC_Utils;

type
  TFM_Reindex = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    LBX_NIndex: TListBox;
    GroupBox3: TGroupBox;
    LBX_WIndex: TListBox;
    BT_Plus: TButton;
    BT_PlusA: TButton;
    BT_Min: TButton;
    BT_MinA: TButton;
    GB_Keuze: TGroupBox;
    GroupBox6: TGroupBox;
    CB_Pack: TCheckBox;
    CB_ReIndex1: TCheckBox;
    Panel1: TPanel;
    BT_Start: TBitBtn;
    Label1: TLabel;
    LB_TeIndex: TLabel;
    Label2: TLabel;
    LB_GeIndex: TLabel;
    CB_Struct: TCheckBox;
    GroupBox4: TGroupBox;
    CB_Leeg: TCheckBox;
    CB_ReIndex2: TCheckBox;
    CB_IniData: TCheckBox;
    GroupBox5: TGroupBox;
    CB_Conversie: TCheckBox;
    CB_Heropbouw: TCheckBox;
    FC: TBFC_FileCheck;
    Panel2: TPanel;
    ProgressBar1: TProgressBar;
    Label3: TLabel;
    GroupBox7: TGroupBox;
    DirectoryEdit1: TDirectoryEdit;
    DirectoryEdit2: TDirectoryEdit;
    Label4: TLabel;
    Label5: TLabel;
    procedure FormShow(Sender: TObject);
    procedure BT_PlusClick(Sender: TObject);
    procedure BT_MinClick(Sender: TObject);
    procedure BT_PlusAClick(Sender: TObject);
    procedure BT_MinAClick(Sender: TObject);
    procedure BT_StartClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DirectoryEdit1Change(Sender: TObject);
  private
    { Private declarations }
  public
  SelectDir : String;
  procedure initialiseer;
    { Public declarations }
  end;

var
  FM_Reindex: TFM_Reindex;

implementation

{$R *.DFM}

procedure TFM_Reindex.FormShow(Sender: TObject);
begin
 Selectdir := DirectoryEdit1.Text;
 Initialiseer;
end;

procedure TFM_Reindex.BT_PlusClick(Sender: TObject);
begin
 if LBX_Nindex.ItemIndex <> -1 then
  begin
    LBX_Windex.Items.Append(LBX_Nindex.Items[LBX_Nindex.Itemindex]);
    LBX_NIndex.Items.Delete(LBX_Nindex.Itemindex);
    LB_TeIndex.Caption := IntToStr(LBX_WIndex.items.count);
  end;
end;

procedure TFM_Reindex.BT_MinClick(Sender: TObject);
begin
 if LBX_Windex.ItemIndex <> -1 then
  begin
    LBX_Nindex.Items.Append(LBX_Windex.Items[LBX_Windex.Itemindex]);
    LBX_WIndex.Items.Delete(LBX_Windex.Itemindex);
    LB_TeIndex.Caption := IntToStr(LBX_WIndex.items.count);
  end;
end;

procedure TFM_Reindex.BT_PlusAClick(Sender: TObject);
begin
 LBX_Windex.Items.AddStrings(LBX_NIndex.items);
 LBX_NIndex.Clear;
 LB_TeIndex.Caption := IntToStr(LBX_WIndex.items.count);
end;

procedure TFM_Reindex.BT_MinAClick(Sender: TObject);
begin
 LBX_Nindex.Items.AddStrings(LBX_WIndex.items);
 LBX_WIndex.Clear;
 LB_TeIndex.Caption := IntToStr(LBX_WIndex.items.count);
end;

procedure TFM_Reindex.BT_StartClick(Sender: TObject);
var teller : Integer;
begin
 Lb_GeIndex.caption := IntToStr(LBX_Windex.Items.Count);
 Try
  for teller := 0 to LBX_Windex.Items.Count -1 do
   begin
    FC.DBIDirectory := DirectoryEdit2.Text;
    FC.FileName := Normaldir(Selectdir)+LBX_Windex.items[Teller];
    FC.Pack := CB_Pack.Checked;
    FC.RebuildIndex := CB_Reindex1.Checked;
    FC.NewIndex := CB_Reindex2.Checked;
    FC.RebuildFile := CB_Heropbouw.Checked;
    FC.NewFile := CB_Leeg.Checked;
    FC.CtrlStruct := CB_Struct.Checked;
    FC.MakeIni := CB_Inidata.Checked;
    FC.ProgramVersion := ProgrammaInfo('Fileversion');
    FC.ProgramName := ProgrammaInfo('ProductName');
    FC.Progressbar := Progressbar1;
    FC.BusyLabel := Label3;
    FC.StartCheck;
    Lb_GeIndex.caption := IntToStr(teller+1);
    update;
   end;
 finally
 end;
 If CB_Conversie.Checked then
  begin
   If FileExists(Normaldir(SelectDir)+'Old*.*') then
    Win95Erase(self.Handle,NormalDir(SelectDir) + 'Old*.*', True, False, False);
   Initialiseer;
  end;
 OK_Infobericht('End check !','Info');
 Label3.Caption := '(C) 2000 Biets Freddy';
 Progressbar1.Position := 0;
end;

procedure TFM_Reindex.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action := caFree;
end;

procedure TFM_Reindex.Initialiseer;
begin
 Vul_bestanden(NormalDir(SelectDir)+'*.db*', LBX_NIndex.items , False);
 Lbx_WIndex.Items.Clear;
 DirectoryEdit1.Text := Selectdir;
end;

procedure TFM_Reindex.DirectoryEdit1Change(Sender: TObject);
begin
 Selectdir := DirectoryEdit1.Text;
 Initialiseer;
end;

end.
